"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const net_1 = require("net");
const events_1 = require("events");
const http_1 = __importDefault(require("http"));
const https_1 = __importDefault(require("https"));
function listen(server, ...args) {
    return __awaiter(this, void 0, void 0, function* () {
        server.listen(...args);
        yield (0, events_1.once)(server, "listening");
        const address = server.address();
        if (typeof address === 'string' || address === null) {
            return address;
        }
        else {
            let protocol;
            if (server instanceof http_1.default.Server)
                protocol = 'http';
            else if (server instanceof https_1.default.Server)
                protocol = 'https';
            else if (server instanceof net_1.Server)
                protocol = 'tcp';
            const { address: hostname, port } = address;
            return new URL(`${protocol}://${hostname === '::' ? '[::]' : hostname}:${port}`);
        }
    });
}
exports.default = listen;
